package main

import (
	"bytes"
	"encoding/binary"
	"fmt"
)

func main() {
	var d uint8 = 2
	fmt.Printf("%08b [D]\n", d)      // 00000010
	fmt.Printf("%08b (NOT D)\n", ^d) // 11111101

	var a uint8 = 0x82
	var b uint8 = 0x02
	fmt.Printf("%08b [A]\n", a)
	fmt.Printf("%08b [B]\n", b)

	fmt.Printf("%08b (NOT B)\n", ^b)
	fmt.Printf("%08b ^ %08b = %08b [B XOR 0xff]\n", b, 0xff, b^0xff)

	fmt.Printf("%08b ^ %08b = %08b [A XOR B]\n", a, b, a^b)
	fmt.Printf("%08b & %08b = %08b [A AND B]\n", a, b, a&b)
	fmt.Printf("%08b &^%08b = %08b [A 'AND NOT' B]\n", a, b, a&^b)
	fmt.Printf("%08b&(^%08b)= %08b [A AND (NOT B)]\n", a, b, a&(^b))

	fmt.Println(IntToBytes(1))
	fmt.Println(BytesToInt([]byte{255, 255, 255, 249}))

}

//整形转换成字节
func IntToBytes(n int) []byte {
	x := int32(n)

	bytesBuffer := bytes.NewBuffer([]byte{})
	binary.Write(bytesBuffer, binary.BigEndian, x)
	return bytesBuffer.Bytes()
}

//字节转换成整形
func BytesToInt(b []byte) int {
	bytesBuffer := bytes.NewBuffer(b)

	var x int32
	binary.Read(bytesBuffer, binary.BigEndian, &x)

	return int(x)
}

func byteOrder() {
	type test struct {
		value      int16
		unionBytes []byte
	}
	// t := test{}
	// test.Value = 0x0102
	// test.unionBytes = unsafe.Sizeof(test.Value)

	// for index := 0; index < unsafe.Sizeof(test.Value); index++ {

	// }
	// if test.unionBytes[0] == 1 && test.unionBytes[0] == 2 {

	// }
}
