package runtime2

import (
	"fmt"
	"reflect"
	"runtime"
	"strings"
	"unsafe"
)


func Setg(g *g) {
	//if g == nil {
	//	setg(nil)
	//} else {
	setg(getG().m.gsignal)
	//}
}

func getG() *g {
	gPtr := getg()
	gStruct := (*g)(gPtr)
	fmt.Println("gStruct:", gStruct)
	val := reflect.ValueOf(gStruct)
	kd := val.Kind()
	println("gStruct kind:", kd != reflect.Ptr, val.Elem().Kind() == reflect.Struct)

	//if kd != reflect.Ptr && val.Elem().Kind() == reflect.Struct {
	//	fmt.Println("expect struct")
	//	return
	//}

	if f, ok := reflect.TypeOf(val).FieldByName("goid"); ok {
		println("goid offset:", f.Offset)
	}

	return gStruct
}

func GetGoid() (id int64) {
	fmt.Println("go version", runtime.Version())
	gPtr := getg()

	idPtr := (*int64)(unsafe.Pointer(uintptr(gPtr) + uintptr(offset)))
	id = *idPtr
	return
}

var offset = func() int64 {
	goversion := runtime.Version()
	for key, off := range offsetDictMap {
		if goversion == key || strings.HasPrefix(goversion, key) {
			return off
		}
	}
	panic("unsupport go verion:" + goversion)
}()

var offsetDictMap = map[string]int64{
	"go1.4":     128,
	"go1.4.1":   128,
	"go1.4.2":   128,
	"go1.4.3":   128,
	"go1.5":     184,
	"go1.5.1":   184,
	"go1.5.2":   184,
	"go1.5.3":   184,
	"go1.5.4":   184,
	"go1.6":     192,
	"go1.6.1":   192,
	"go1.6.2":   192,
	"go1.6.3":   192,
	"go1.6.4":   192,
	"go1.7":     192,
	"go1.7.1":   192,
	"go1.7.2":   192,
	"go1.7.3":   192,
	"go1.7.4":   192,
	"go1.7.5":   192,
	"go1.7.6":   192,
	"go1.8":     192,
	"go1.8.1":   192,
	"go1.8.2":   192,
	"go1.8.3":   192,
	"go1.8.4":   192,
	"go1.8.5":   192,
	"go1.9":     152,
	"go1.9.1":   152,
	"go1.9.2":   152,
	"go1.10":    152,
	"go1.10.1":  152,
	"go1.10.2":  152,
	"go1.10.3":  152,
	"go1.10.4":  152,
	"go1.10.5":  152,
	"go1.10.6":  152,
	"go1.10.7":  152,
	"go1.10.8":  152,
	"go1.11":    152,
	"go1.11.1":  152,
	"go1.11.2":  152,
	"go1.11.3":  152,
	"go1.11.4":  152,
	"go1.11.5":  152,
	"go1.11.6":  152,
	"go1.11.7":  152,
	"go1.11.8":  152,
	"go1.11.9":  152,
	"go1.11.10": 152,
	"go1.11.11": 152,
	"go1.12":    152,
	"go1.12.1":  152,
	"go1.12.2":  152,
	"go1.12.3":  152,
	"go1.12.4":  152,
	"go1.12.5":  152,
	"go1.12.6":  152,
	"go1.12.7":  152,
}
